// Title:       Sudoku
// Version:     0.9
// Copyright:   2011
// Author:      Fernando Berzal Galiano
// E-mail:      berzal@acm.org

import java.util.Date;

/**
* Prueba bsica de un Sudoku.
* 
* @author Fernando Berzal
*/

public class SudokuDriver 
{
	public static final String SUDOKU_POR_DEFECTO = "97.3.4.65"
		                                          + ".2.5.6.8."
		                                          + "........."
		                                          + "..58.29.."
		                                          + "..2.4.3.."
		                                          + "..87.51.."
		                                          + "........."
		                                          + ".6.2.8.3."
		                                          + "84.1.9.27";

		
	public static void main (String args[])
	{
		String       plantilla;
		AbstractSudokuSolver sudoku;
		long inicio;
		long fin;
		long tiempo;
		boolean solved;
		
		// Argumentos de entrada
		
		if (args.length==0) {
			
			System.err.println("Por favor, indique su sudoku como argumento de este programa.");
			System.err.println("Asumiendo sudoku por defecto...");
			plantilla = SUDOKU_POR_DEFECTO;
			
		} else {
			
			plantilla = "";
			
			for (int i=0;i<args.length; i++)
				plantilla += args[i];
			
		}
		
		
		sudoku = new BacktrackingSudokuSolver (plantilla);

		System.out.println("Sudoku:");
		System.out.println(sudoku.toString());
	
		// Resolucin del sudoku

		inicio = (new Date()).getTime();
		
		solved = sudoku.solve();
		
		fin = (new Date()).getTime();
		
		tiempo = fin - inicio;
		
		
		// Resultado
		
		if (solved) {
			System.out.println("Solucin:");
			System.out.println(sudoku.toString());
		} else {
			System.out.println("No se pudo resolver el Sudoku.");
		}

		System.out.println("Tiempo: "+tiempo+" milisegundos.");
	}

}
